hpi_objects = {1: 'SUBSYSTEM', 2: 'ADAPTER', 3: 'OSTREAM', 4: 'ISTREAM', 5: 'MIXER', 6: 'NODE', 7: 'CONTROL', 8: 'NVMEMORY', 9: 'GPIO', 10: 'WATCHDOG', 11: 'CLOCK', 12: 'PROFILE', 14: 'ASYNCEVENT'}

hpi_functions = {513: 'ADAPTER_OPEN', 514: 'ADAPTER_CLOSE', 1027: 'ISTREAM_SET_FORMAT', 516: 'ADAPTER_GET_ASSERT', 517: 'ADAPTER_TEST_ASSERT', 518: 'ADAPTER_SET_MODE', 519: 'ADAPTER_GET_MODE', 520: 'ADAPTER_ENABLE_CAPABILITY', 521: 'ADAPTER_SELFTEST', 522: 'ADAPTER_FIND_OBJECT', 523: 'ADAPTER_QUERY_FLASH', 1036: 'ISTREAM_ANC_WRITE', 525: 'ADAPTER_PROGRAM_FLASH', 1038: 'ISTREAM_HOSTBUFFER_FREE', 1039: 'ISTREAM_GROUP_ADD', 1040: 'ISTREAM_GROUP_GETMAP', 1041: 'ISTREAM_GROUP_RESET', 530: 'ADAPTER_DEBUG_READ', 515: 'ADAPTER_GET_INFO', 532: 'ADAPTER_IRQ_CALLBACK', 533: 'ADAPTER_DELETE', 534: 'ADAPTER_READ_FLASH', 1028: 'ISTREAM_READ', 1029: 'ISTREAM_START', 774: 'OSTREAM_RESET', 1031: 'ISTREAM_RESET', 776: 'OSTREAM_QUERY_FORMAT', 777: 'OSTREAM_DATA', 769: 'OSTREAM_OPEN', 1034: 'ISTREAM_ANC_RESET', 1035: 'ISTREAM_ANC_GET_INFO', 1025: 'ISTREAM_OPEN', 780: 'OSTREAM_SINEGEN', 1281: 'MIXER_OPEN', 781: 'OSTREAM_ANC_RESET', 531: 'ADAPTER_IRQ_QUERY_AND_CLEAR', 782: 'OSTREAM_ANC_GET_INFO', 770: 'OSTREAM_CLOSE', 527: 'ADAPTER_GET_PROPERTY', 1793: 'CONTROL_GET_INFO', 528: 'ADAPTER_ENUM_PROPERTY', 1026: 'ISTREAM_CLOSE', 2049: 'NVMEMORY_OPEN', 529: 'ADAPTER_MODULE_INFO', 785: 'OSTREAM_SET_FORMAT', 1282: 'MIXER_CLOSE', 2305: 'GPIO_OPEN', 1042: 'ISTREAM_HOSTBUFFER_GET_INFO', 1043: 'ISTREAM_WAIT_START', 2561: 'WATCHDOG_OPEN', 771: 'OSTREAM_WRITE', 1044: 'ISTREAM_WAIT', 1794: 'CONTROL_GET_STATE', 2817: 'CLOCK_OPEN', 2050: 'NVMEMORY_READ_BYTE', 3073: 'PROFILE_OPEN_ALL', 1283: 'MIXER_GET_INFO', 2306: 'GPIO_READ_BIT', 2562: 'WATCHDOG_SET_TIME', 3585: 'ASYNCEVENT_OPEN', 1795: 'CONTROL_SET_STATE', 2818: 'CLOCK_SET_TIME', 2051: 'NVMEMORY_WRITE_BYTE', 3074: 'PROFILE_START_ALL', 1284: 'MIXER_GET_NODE_INFO', 2307: 'GPIO_WRITE_BIT', 2563: 'WATCHDOG_PING', 3586: 'ASYNCEVENT_CLOSE', 773: 'OSTREAM_STOP', 2819: 'CLOCK_GET_TIME', 3075: 'PROFILE_STOP_ALL', 1285: 'MIXER_GET_CONTROL', 2308: 'GPIO_READ_ALL', 3587: 'ASYNCEVENT_WAIT', 1030: 'ISTREAM_STOP', 3076: 'PROFILE_GET', 1286: 'MIXER_SET_CONNECTION', 2309: 'GPIO_WRITE_STATUS', 3588: 'ASYNCEVENT_GETCOUNT', 3077: 'PROFILE_GET_IDLECOUNT', 1287: 'MIXER_GET_CONNECTIONS', 257: 'SUBSYS_OPEN', 258: 'SUBSYS_GET_VERSION', 259: 'SUBSYS_GET_INFO', 772: 'OSTREAM_START', 261: 'SUBSYS_CREATE_ADAPTER', 262: 'SUBSYS_CLOSE', 775: 'OSTREAM_GET_INFO', 264: 'SUBSYS_DRIVER_LOAD', 265: 'SUBSYS_DRIVER_UNLOAD', 778: 'OSTREAM_SET_VELOCITY', 779: 'OSTREAM_SET_PUNCHINOUT', 268: 'SUBSYS_GET_NUM_ADAPTERS', 269: 'SUBSYS_GET_ADAPTER', 270: 'SUBSYS_SET_NETWORK_INTERFACE', 271: 'SUBSYS_OPTION_INFO', 272: 'SUBSYS_OPTION_GET', 273: 'SUBSYS_OPTION_SET', 786: 'OSTREAM_HOSTBUFFER_ALLOC', 787: 'OSTREAM_HOSTBUFFER_FREE', 788: 'OSTREAM_GROUP_ADD', 789: 'OSTREAM_GROUP_GETMAP', 790: 'OSTREAM_GROUP_RESET', 791: 'OSTREAM_HOSTBUFFER_GET_INFO', 792: 'OSTREAM_WAIT_START', 793: 'OSTREAM_WAIT', 3078: 'PROFILE_GET_NAME', 1288: 'MIXER_GET_CONTROL_BY_INDEX', 3590: 'ASYNCEVENT_SENDEVENTS', 1033: 'ISTREAM_QUERY_FORMAT', 3079: 'PROFILE_GET_UTILIZATION', 1289: 'MIXER_GET_CONTROL_ARRAY_BY_INDEX', 3589: 'ASYNCEVENT_GET', 1290: 'MIXER_GET_CONTROL_MULTIPLE_VALUES', 1032: 'ISTREAM_GET_INFO', 1291: 'MIXER_STORE', 524: 'ADAPTER_START_FLASH', 1292: 'MIXER_GET_CACHE_INFO', 1037: 'ISTREAM_HOSTBUFFER_ALLOC', 526: 'ADAPTER_SET_PROPERTY', 783: 'OSTREAM_ANC_READ', 784: 'OSTREAM_SET_TIMESCALE'}

hpi_controls = {0: 'GENERIC', 1: 'CONNECTION', 2: 'VOLUME', 3: 'METER', 4: 'MUTE', 5: 'MULTIPLEXER', 6: 'AESEBUTX', 7: 'AESEBURX', 8: 'LEVEL', 9: 'TUNER', 11: 'VOX', 15: 'CHANNEL_MODE', 16: 'BITSTREAM', 17: 'SAMPLECLOCK', 18: 'MICROPHONE', 19: 'EQUALIZER', 20: 'COMPANDER', 21: 'COBRANET', 22: 'TONEDETECTOR', 23: 'SILENCEDETECTOR', 24: 'PAD', 25: 'SRC', 26: 'UNIVERSAL'}

hpi_control_attributes = {5123: 'COMPANDER_THRESHOLD', 1: 'GENERIC_ENABLE', 1794: 'AESEBURX_ERRORSTATUS', 515: 'VOLUME_MUTE', 516: 'VOLUME_GAIN_AND_FLAGS', 773: 'METER_NUM_CHANNELS', 518: 'VOLUME_NUM_CHANNELS', 513: 'VOLUME_GAIN', 2312: 'TUNER_MODE', 2313: 'TUNER_RDS', 522: 'VOLUME_RANGE', 2315: 'TUNER_PROGRAM', 2316: 'TUNER_HDRADIO_SIGNAL_QUALITY', 2: 'GENERIC_EVENT_ENABLE', 2318: 'TUNER_HDRADIO_DSP_VERSION', 2319: 'TUNER_HDRADIO_BLEND', 5635: 'TONEDETECTOR_FREQUENCY', 6146: 'PAD_ARTIST', 1539: 'AESEBUTX_SAMPLERATE', 6145: 'PAD_CHANNEL_NAME', 772: 'METER_PEAK_BALLISTICS', 1795: 'AESEBURX_SAMPLERATE', 1540: 'AESEBUTX_CHANNELSTATUS', 5889: 'SILENCEDETECTOR_THRESHOLD', 3841: 'CHANNEL_MODE_MODE', 5124: 'COMPANDER_RATIO', 1541: 'AESEBUTX_USERDATA', 6147: 'PAD_TITLE', 4356: 'SAMPLECLOCK_LOCAL_SAMPLERATE', 4097: 'BITSTREAM_DATA_POLARITY', 2310: 'TUNER_GAIN', 1797: 'AESEBURX_USERDATA', 2307: 'TUNER_LEVEL_AVG', 5633: 'TONEDETECTOR_THRESHOLD', 2311: 'TUNER_STATUS', 4353: 'SAMPLECLOCK_SOURCE', 5379: 'I_COBRANET_SET_DATA', 4865: 'EQUALIZER_NUM_FILTERS', 4358: 'SAMPLECLOCK_LOCAL_LOCK', 4609: 'MICROPHONE_PHANTOM_POWER', 2306: 'TUNER_FREQ', 1796: 'AESEBURX_CHANNELSTATUS', 5377: 'COBRANET_SET', 4357: 'SAMPLECLOCK_AUTO', 5891: 'SILENCEDETECTOR_DELAY', 769: 'METER_RMS', 2058: 'LEVEL_RANGE', 6148: 'PAD_COMMENT', 4098: 'BITSTREAM_CLOCK_EDGE', 5381: 'COBRANET_GET_STATUS', 5121: 'COMPANDER_PARAMS', 2308: 'TUNER_LEVEL_RAW', 4866: 'EQUALIZER_FILTER', 5126: 'COMPANDER_DECAY', 4354: 'SAMPLECLOCK_SAMPLERATE', 5383: 'COBRANET_GET_PACKET', 1281: 'MULTIPLEXER_SOURCE', 2317: 'TUNER_HDRADIO_SDK_VERSION', 514: 'VOLUME_AUTOFADE', 6149: 'PAD_PROGRAM_TYPE', 1537: 'AESEBUTX_FORMAT', 5380: 'I_COBRANET_GET_DATA', 770: 'METER_PEAK', 1793: 'AESEBURX_FORMAT', 4867: 'EQUALIZER_COEFFICIENTS', 4099: 'BITSTREAM_CLOCK_SOURCE', 6152: 'PAD_TA_ACTIVE', 5122: 'COMPANDER_MAKEUPGAIN', 2049: 'LEVEL_GAIN', 5890: 'SILENCEDETECTOR_STATE', 4355: 'SAMPLECLOCK_SOURCE_INDEX', 6150: 'PAD_PROGRAM_ID', 1282: 'MULTIPLEXER_QUERYSOURCE', 2305: 'TUNER_BAND', 5382: 'COBRANET_SEND_PACKET', 5634: 'TONEDETECTOR_STATE', 2309: 'TUNER_SNR', 771: 'METER_RMS_BALLISTICS', 5378: 'COBRANET_GET', 2314: 'TUNER_DEEMPHASIS', 5125: 'COMPANDER_ATTACK', 2817: 'VOX_THRESHOLD', 4100: 'BITSTREAM_ACTIVITY', 6151: 'PAD_TA_SUPPORT'}

hpi_errors = {473: 'ENTITY_ROLE_INVALID', 900: 'DSP_COMMUNICATION', 470: 'ENTITY_TYPE_MISMATCH', 600: 'CUSTOM', 471: 'ENTITY_ITEM_COUNT', 400: 'INVALID_NODE', 401: 'INVALID_CONTROL', 402: 'INVALID_CONTROL_VALUE', 403: 'INVALID_CONTROL_ATTRIBUTE', 404: 'CONTROL_DISABLED', 405: 'I2C_MISSING_ACK', 406: 'UNSUPPORTED_CONTROL_ATTRIBUTE', 407: 'CONTROL_NOT_READY', 290: 'RESERVED_1', 700: 'MUTEX_TIMEOUT', 305: 'INVALID_DATASIZE', 301: 'INVALID_FORMAT', 302: 'INVALID_SAMPLERATE', 303: 'INVALID_CHANNELS', 304: 'INVALID_BITRATE', 229: 'FLASH_READ_NO_FILE', 308: 'INVALID_DATA_POINTER', 309: 'INVALID_PACKET_ORDER', 310: 'INVALID_OPERATION', 311: 'INCOMPATIBLE_SAMPLERATE', 312: 'BAD_ADAPTER_MODE', 313: 'TOO_MANY_CAPABILITY_CHANGE_ATTEMPTS', 314: 'NO_INTERADAPTER_GROUPS', 315: 'NO_INTERDSP_GROUPS', 316: 'WAIT_CANCELLED', 472: 'ENTITY_TYPE_INVALID', 450: 'NVMEM_BUSY', 451: 'NVMEM_FULL', 452: 'NVMEM_FAIL', 228: 'FLASH_READ', 201: 'BAD_ADAPTER', 202: 'BAD_ADAPTER_NUMBER', 203: 'DUPLICATE_ADAPTER_NUMBER', 204: 'DSP_BOOTLOAD', 206: 'DSP_FILE_NOT_FOUND', 207: 'DSP_HARDWARE', 208: 'MEMORY_ALLOC', 209: 'PLD_LOAD', 210: 'DSP_FILE_FORMAT', 211: 'DSP_FILE_ACCESS_DENIED', 212: 'DSP_FILE_NO_HEADER', 214: 'DSP_SECTION_NOT_FOUND', 215: 'DSP_FILE_OTHER_ERROR', 216: 'DSP_FILE_SHARING_VIOLATION', 217: 'DSP_FILE_NULL_HEADER', 474: 'ENTITY_SIZE_MISMATCH', 221: 'BAD_CHECKSUM', 222: 'BAD_SEQUENCE', 223: 'FLASH_ERASE', 224: 'FLASH_PROGRAM', 225: 'FLASH_VERIFY', 226: 'FLASH_TYPE', 227: 'FLASH_START', 100: 'INVALID_TYPE', 101: 'INVALID_OBJ', 102: 'INVALID_FUNC', 103: 'INVALID_OBJ_INDEX', 104: 'OBJ_NOT_OPEN', 105: 'OBJ_ALREADY_OPEN', 106: 'INVALID_RESOURCE', 108: 'INVALID_RESPONSE', 109: 'PROCESSING_MESSAGE', 110: 'NETWORK_TIMEOUT', 111: 'INVALID_HANDLE', 112: 'UNIMPLEMENTED', 113: 'NETWORK_TOO_MANY_CLIENTS', 114: 'RESPONSE_BUFFER_TOO_SMALL', 115: 'RESPONSE_MISMATCH', 116: 'CONTROL_CACHING', 117: 'MESSAGE_BUFFER_TOO_SMALL', 460: 'I2C_BAD_ADR'}

hpi_formats = {0: 'MIXER_NATIVE', 1: 'PCM8_UNSIGNED', 2: 'PCM16_SIGNED', 3: 'MPEG_L1', 4: 'MPEG_L2', 5: 'MPEG_L3', 6: 'DOLBY_AC2', 7: 'DOLBY_AC3', 8: 'PCM16_BIGENDIAN', 9: 'AA_TAGIT1_HITS', 10: 'AA_TAGIT1_INSERTS', 11: 'PCM32_SIGNED', 12: 'RAW_BITSTREAM', 13: 'AA_TAGIT1_HITS_EX1', 14: 'PCM32_FLOAT', 15: 'PCM24_SIGNED', 16: 'OEM1', 17: 'OEM2', 65535: 'UNDEFINED'}

